// Dictionary.h: interface for the Dictionary class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICTIONARY_H__3979F565_0AB1_439F_86D8_B173673E22BF__INCLUDED_)
#define AFX_DICTIONARY_H__3979F565_0AB1_439F_86D8_B173673E22BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

const long MAXNUMWORDS = 200000;
class Dictionary  
{
public:
	bool find(CString word);
	// Precondition:	loadDictionary must be called to load a dictionary into the class
	// Postcondition:	returns TRUE if word is found in dictionary
	//					returns FALSE otherwise

	void display();
	// Precondition:	none
	// Postcondition:   displays list of dictionary entries to standard output

	void loadDictionary();
	// Precondition:	filename must be set either through the constructor or explicitly
	// Postcondition:	dictionary loaded from file into class instance, 
	//					words[] contains each entry as a CString pointer
	//					numWords contains the total number of dictionary entries

	Dictionary(CString filename);
	// Precondition:	filename is the name of the dictionary file to read in
	// Postcondition:	numWords set to 0
	//					filename set to filename passed in as parameter

	Dictionary();
	// Precondition:	none
	// Postcondition:	numWords set to 0

	virtual ~Dictionary();
	// Precondition:	none
	// Postcondition:	All CString instances allocated in words[] array are released to 
	//                  avoid memory leaks

protected:
	// Filename of dictionary file to load words from
	CString filename;
	
	// Number of words in the dictionary
	long numWords;

	// Array containing dictionary words
	CString* words[MAXNUMWORDS];

};

#endif // !defined(AFX_DICTIONARY_H__3979F565_0AB1_439F_86D8_B173673E22BF__INCLUDED_)
